/***********************************************************************
 *      ̃TvvO͈ȉ̏Ђ̔łB             *
 *                                                                     *
 *          X Window OSF/Motif c[Lbg vO~O (II)        *
 *            - OtBbNEƎ\[XE{EʐM -             *
 *                                                                     *
 *      Copyright 1995,  GK                                        *
 *                                                                     *
 *      쌠\Ƃ̒ӏ܂܂ĂA                   *
 *      ̃TvvOzzĂ܂܂B                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

extern Boolean CvtStrToBitmap(); /* \[XERo[^ */

static GC gc; /* OtBbNEReLXg (Xlib ̕`ɕKv) */

typedef struct {  /* (1) \[Xli[\̂̒` */
    Pixmap bitmap;      /* sbNX}bv */
} CustomRec, *CustomPtr;

static XtResource res[] = {  /* (2) Ǝ\[X̒` */
  {"bitmap", "Bitmap", XtRBitmap, sizeof(Pixmap), XtOffsetOf(CustomRec, bitmap),
   XtRImmediate, (XtPointer) XtUnspecifiedPixmap},
};

static XrmOptionDescRec opt[] = { /* (3) ƎIvV̒` */
  {"-bm", "*canvas.bitmap", XrmoptionSepArg, NULL},
};

/* (4) h[GAIo܂̓TCYƁCsbNX}bvĕ\ */
static void RedrawCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    Pixmap bitmap = (Pixmap)client_data;
    XmDrawingAreaCallbackStruct *cb = (XmDrawingAreaCallbackStruct *)call_data;
    Window r;
    int x, y;
    unsigned int pw, ph, bw, d;
    Dimension dw, dh;

    if (bitmap == XtUnspecifiedPixmap)
        return;
    /* sbNX}bṽTCY𒲂ׂ */
    if (XGetGeometry(XtDisplay(w), bitmap, &r, &x, &y, &pw, &ph, &bw, &d) == 0)
        return;

    /* h[GÃTCYςƁCEBhENA */
    if (cb->reason == XmCR_RESIZE)
        XClearWindow(XtDisplay(w), cb->window);

    /* h[GÃTCY𒲂ׂ */
    XtVaGetValues(w, XmNwidth,  &dw, XmNheight, &dh, NULL);

    /* h[GA̒ɃsbNX}bv\ */
    XCopyArea(XtDisplay(w), bitmap, cb->window, gc, 0, 0, pw, ph,
              (dw - pw) / 2, (dh - ph) / 2);
}

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, canvas;
    Arg    al[20];
    int    ac;
    CustomRec data;  /* \[Xli[\ */
    XtConvertArgRec args[2];  /* \[XERo[^ɓn⏕f[^ */
    Screen *screen;

    XtSetLanguageProc(NULL, NULL, NULL);
    ac = 0;       /* \[XEf[^x[X */
    toplevel = XtAppInitialize(&app_context, "Bitmapres", opt, XtNumber(opt),
                               &argc, argv, NULL, al, ac);

    /* (5) \[XERo[^ɓn⏕f[^ */
    screen = XtScreen(toplevel);
    args[0].address_mode = XtAddress;
    args[0].address_id = (XtPointer)&screen;
    args[0].size = sizeof(Screen *);
    args[1].address_mode = XtAddress;
    args[1].address_id = (XtPointer)&canvas;
    args[1].size = sizeof(Widget);

    /* (6) rbg}bvEt@C Pixmap ւ̃\[XERo[^o^ */
    XtAppSetTypeConverter(app_context, XtRString, XtRBitmap, CvtStrToBitmap,
                          args, XtNumber(args), XtCacheByDisplay, NULL);

    ac = 0;
    panel = XmCreateForm(toplevel, "panel", al, ac);
    XtManageChild(panel);

    ac = 0;
    canvas = XmCreateDrawingArea(panel, "canvas", al, ac);
    XtManageChild(canvas);

    /* (7) Ǝ\[Xl̎o (\[XERo[^Ăяo) */
    XtGetApplicationResources(canvas, &data, res, XtNumber(res), NULL, 0);
            /* ꂽsbNX}bv data.bitmap Ɋi[ */
    XtAddCallback(canvas, XmNexposeCallback, RedrawCB, data.bitmap);
    XtAddCallback(canvas, XmNresizeCallback, RedrawCB, data.bitmap);

    XtRealizeWidget(toplevel);
    gc = XCreateGC(XtDisplay(canvas), XtWindow(canvas), NULL, NULL);
    XtAppMainLoop(app_context);
}
